/*
      Special CPU timing routine for Hewlett-Packard
      Written by Shinichi Yamada,
      YHP (Yokogawa Hewlett-Packard), Tokyo, Japan.  in Nov 1992.
      wall timing modified by Dave Mullally (Convex) in Jun 1994.
      Francois Rotzinger (Lausanne) renamed etime --> hptme Jun 1995.
 
      This is a clone of the usual Unix ETIME function,
      except usage is as a subroutine call,
        REAL XTIME(2)
        CALL HPTME(XTIME)
 
      HPTME will return two values:
        xtime(1)      <==== user cpu time    ( sec )
        xtime(2)      <==== system cpu time  ( sec )
      add the latter two to get actual CPU time.
*/

#include <sys/types.h>
#include <sys/times.h>
#include <unistd.h>
#include <sys/time.h>
void hptme(hptme_val)
float *hptme_val;
{
struct tms      buf;
static float  clock_val=0.0;
if ( clock_val == 0.0 ) {
  clock_val = (float)sysconf(_SC_CLK_TCK);
}
times(&buf);
*hptme_val = (float)(buf.tms_utime);
*hptme_val = *hptme_val/clock_val;
hptme_val++;
*hptme_val = (float)(buf.tms_stime);
*hptme_val = *hptme_val/clock_val;
return;
}
void walltim(hptme1)
double  *hptme1;
{
struct timeval   time_sec;
struct timezone  tzone;
float  clock_val;
gettimeofday(&time_sec,&tzone);
*hptme1 = (double)time_sec.tv_sec;
return;
}
