/*  2 July 1997 

   Dynamic memory allocation for Unix systems.
     January 1990 - implemented by Steve Elbert.
   August 1, 1990 - AIX requires 'laddrs' by John Montgomery
 
   Unix FORTRAN compilers may require that C subprograms be
   spelled in lower or upper case, and with or without a trailing
   underscore, so the code is duplicated for all possibilities.

   To use on machines with 64 bit integers and very large physical
   memory, change data type for 'nbytes' from 'int' to 'long'.
 
   ======
   MEMGET
   ======
   function invocation only: LOCMEM = MEMGET(NWORDS)
          NWORDS is the no. of 8-byte words of memory requested.
          The return value is the address of the allocated memory,
          zero means failure.
*/
memget_(nwords) int *nwords;
   { int nbytes;
     nbytes = (*nwords+2)*8;
     return malloc(nbytes); }
 
MEMGET_(nwords) int *nwords;
   { int nbytes;
     nbytes = (*nwords+2)*8;
     return malloc(nbytes); }
 
MEMGET(nwords) int *nwords;
   { int nbytes;
     nbytes = (*nwords+2)*8;
     return malloc(nbytes); }
 
memget(nwords) int *nwords;
   { int nbytes;
     nbytes = (*nwords+2)*8;
     return malloc(nbytes); }
 
/*
   ======
   MEMREL
   ======
   subroutine call only: CALL MEMREL(LOCMEM)
          Deallocate all memory above the address LOCMEM.
          (deallocated memory is not returned to system)
*/
void memrel_(locmem) int *locmem;
   { free(*locmem); }
 
void MEMREL_(locmem) int *locmem;
   { free(*locmem); }
 
void MEMREL(locmem) int *locmem;
   { free(*locmem); }

void memrel(locmem) int *locmem;
   { free(*locmem); }

/*
   ======
   LADDRS
   ======
   function invocation only: LOCX = LADDRS(X)
          Returns the absolute address of X, in bytes.
          This clone of LOC is used only when the FORTRAN 
          library does not include LOC already.
*/
laddrs_(arg) int arg;
   { return(arg); }

laddrs(arg) int arg;
   { return(arg); }

LADDRS_(arg) int arg;
   { return(arg); }

LADDRS(arg) int arg;
   { return(arg); }
